linux/version.h not found

Hi,

 

I am trying to compile Talpa 1.11.0 on my Ubuntu 16.04 but getting an error as below

checking for kernel headers layout... /lib/modules/4.15.0-45-generic/build/include:/lib/modules/4.15.0-45-generic/build/arch/x86/include
checking for linux/version.h... configure: error: cannot proceed without the required header file

Any help in this is appreciated.

Thank you

  • Hi  

    Please provide the full talpaselect.log to get the exact error of why the header file is not in place.

  • In reply to Jasmin:

    Please find below the details logs as in config.log

     

    This file contains any messages produced by compilers while
    running configure, to aid debugging if configure makes a mistake.

    It was created by talpa configure 1.11.0, which was
    generated by GNU Autoconf 2.59. Invocation command line was

    $ ./configure

    ## --------- ##
    ## Platform. ##
    ## --------- ##

    hostname = abhishek-VM
    uname -m = x86_64
    uname -r = 4.15.0-45-generic
    uname -s = Linux
    uname -v = #48~16.04.1-Ubuntu SMP Tue Jan 29 18:03:48 UTC 2019

    /usr/bin/uname -p = unknown
    /bin/uname -X = unknown

    /bin/arch = unknown
    /usr/bin/arch -k = unknown
    /usr/convex/getsysinfo = unknown
    hostinfo = unknown
    /bin/machine = unknown
    /usr/bin/oslevel = unknown
    /bin/universe = unknown

    PATH: /usr/local/sbin
    PATH: /usr/local/bin
    PATH: /usr/sbin
    PATH: /usr/bin
    PATH: /sbin
    PATH: /bin
    PATH: /snap/bin


    ## ----------- ##
    ## Core tests. ##
    ## ----------- ##

    configure:1353: checking for a BSD-compatible install
    configure:1408: result: /usr/bin/install -c
    configure:1419: checking whether build environment is sane
    configure:1462: result: yes
    configure:1527: checking for gawk
    configure:1556: result: no
    configure:1527: checking for mawk
    configure:1543: found /usr/bin/mawk
    configure:1553: result: mawk
    configure:1563: checking whether make sets $(MAKE)
    configure:1583: result: yes
    configure:1746: checking how to create a ustar tar archive
    configure:1759: tar --version
    tar (GNU tar) 1.28
    Copyright (C) 2014 Free Software Foundation, Inc.
    License GPLv3+: GNU GPL version 3 or later <gnu.org/.../gpl.html>.
    This is free software: you are free to change and redistribute it.
    There is NO WARRANTY, to the extent permitted by law.

    Written by John Gilmore and Jay Fenlason.
    configure:1762: $? = 0
    configure:1802: tardir=conftest.dir && eval tar --format=ustar -chf - "$tardir" >conftest.tar
    configure:1805: $? = 0
    configure:1809: tar -xf - <conftest.tar
    configure:1812: $? = 0
    configure:1825: result: gnutar
    configure:1977: checking how to create a ustar tar archive
    configure:1990: tar --version
    tar (GNU tar) 1.28
    Copyright (C) 2014 Free Software Foundation, Inc.
    License GPLv3+: GNU GPL version 3 or later <gnu.org/.../gpl.html>.
    This is free software: you are free to change and redistribute it.
    There is NO WARRANTY, to the extent permitted by law.

    Written by John Gilmore and Jay Fenlason.
    configure:1993: $? = 0
    configure:2056: result: gnutar
    configure:2065: checking whether to enable maintainer-specific portions of Makefiles
    configure:2074: result: no
    configure:2139: checking for gcc
    configure:2155: found /usr/bin/gcc
    configure:2165: result: gcc
    configure:2409: checking for C compiler version
    configure:2412: gcc --version </dev/null >&5
    gcc (Ubuntu 5.4.0-6ubuntu1~16.04.11) 5.4.0 20160609
    Copyright (C) 2015 Free Software Foundation, Inc.
    This is free software; see the source for copying conditions. There is NO
    warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    configure:2415: $? = 0
    configure:2417: gcc -v </dev/null >&5
    Using built-in specs.
    COLLECT_GCC=gcc
    COLLECT_LTO_WRAPPER=/usr/lib/gcc/x86_64-linux-gnu/5/lto-wrapper
    Target: x86_64-linux-gnu
    Configured with: ../src/configure -v --with-pkgversion='Ubuntu 5.4.0-6ubuntu1~16.04.11' --with-bugurl=file:///usr/share/doc/gcc-5/README.Bugs --enable-languages=c,ada,c++,java,go,d,fortran,objc,obj-c++ --prefix=/usr --program-suffix=-5 --enable-shared --enable-linker-build-id --libexecdir=/usr/lib --without-included-gettext --enable-threads=posix --libdir=/usr/lib --enable-nls --with-sysroot=/ --enable-clocale=gnu --enable-libstdcxx-debug --enable-libstdcxx-time=yes --with-default-libstdcxx-abi=new --enable-gnu-unique-object --disable-vtable-verify --enable-libmpx --enable-plugin --with-system-zlib --disable-browser-plugin --enable-java-awt=gtk --enable-gtk-cairo --with-java-home=/usr/lib/jvm/java-1.5.0-gcj-5-amd64/jre --enable-java-home --with-jvm-root-dir=/usr/lib/jvm/java-1.5.0-gcj-5-amd64 --with-jvm-jar-dir=/usr/lib/jvm-exports/java-1.5.0-gcj-5-amd64 --with-arch-directory=amd64 --with-ecj-jar=/usr/share/java/eclipse-ecj.jar --enable-objc-gc --enable-multiarch --disable-werror --with-arch-32=i686 --with-abi=m64 --with-multilib-list=m32,m64,mx32 --enable-multilib --with-tune=generic --enable-checking=release --build=x86_64-linux-gnu --host=x86_64-linux-gnu --target=x86_64-linux-gnu
    Thread model: posix
    gcc version 5.4.0 20160609 (Ubuntu 5.4.0-6ubuntu1~16.04.11)
    configure:2420: $? = 0
    configure:2422: gcc -V </dev/null >&5
    gcc: error: unrecognized command line option '-V'
    gcc: fatal error: no input files
    compilation terminated.
    configure:2425: $? = 1
    configure:2448: checking for C compiler default output file name
    configure:2451: gcc conftest.c >&5
    configure:2454: $? = 0
    configure:2500: result: a.out
    configure:2505: checking whether the C compiler works
    configure:2511: ./a.out
    configure:2514: $? = 0
    configure:2531: result: yes
    configure:2538: checking whether we are cross compiling
    configure:2540: result: no
    configure:2543: checking for suffix of executables
    configure:2545: gcc -o conftest conftest.c >&5
    configure:2548: $? = 0
    configure:2573: result:
    configure:2579: checking for suffix of object files
    configure:2600: gcc -c conftest.c >&5
    configure:2603: $? = 0
    configure:2625: result: o
    configure:2629: checking whether we are using the GNU C compiler
    configure:2653: gcc -c conftest.c >&5
    configure:2659: $? = 0
    configure:2663: test -z
    || test ! -s conftest.err
    configure:2666: $? = 0
    configure:2669: test -s conftest.o
    configure:2672: $? = 0
    configure:2685: result: yes
    configure:2691: checking whether gcc accepts -g
    configure:2712: gcc -c -g conftest.c >&5
    configure:2718: $? = 0
    configure:2722: test -z
    || test ! -s conftest.err
    configure:2725: $? = 0
    configure:2728: test -s conftest.o
    configure:2731: $? = 0
    configure:2742: result: yes
    configure:2759: checking for gcc option to accept ANSI C
    configure:2829: gcc -c -g -O2 conftest.c >&5
    configure:2835: $? = 0
    configure:2839: test -z
    || test ! -s conftest.err
    configure:2842: $? = 0
    configure:2845: test -s conftest.o
    configure:2848: $? = 0
    configure:2866: result: none needed
    configure:2884: gcc -c -g -O2 conftest.c >&5
    conftest.c:2:3: error: unknown type name 'choke'
    choke me
    ^
    conftest.c:2:3: error: expected '=', ',', ';', 'asm' or '__attribute__' at end of input
    configure:2890: $? = 1
    configure: failed program was:
    | #ifndef __cplusplus
    | choke me
    | #endif
    configure:3034: checking for style of include used by make
    configure:3062: result: GNU
    configure:3090: checking dependency style of gcc
    configure:3180: result: gcc3
    configure:3199: checking dependency style of gcc
    configure:3289: result: gcc3
    configure:3307: checking whether gcc and cc understand -c and -o together
    configure:3337: gcc -c conftest.c -o conftest.o >&5
    configure:3340: $? = 0
    configure:3342: gcc -c conftest.c -o conftest.o >&5
    configure:3345: $? = 0
    configure:3352: cc -c conftest.c >&5
    configure:3355: $? = 0
    configure:3358: cc -c conftest.c -o conftest.o >&5
    configure:3361: $? = 0
    configure:3363: cc -c conftest.c -o conftest.o >&5
    configure:3366: $? = 0
    configure:3384: result: yes
    configure:3450: checking for ld
    configure:3466: found /usr/bin/ld
    configure:3477: result: ld
    configure:3489: checking for egrep
    configure:3499: result: grep -E
    configure:3506: checking for cat
    configure:3524: found /bin/cat
    configure:3536: result: /bin/cat
    configure:3545: checking for cut
    configure:3563: found /usr/bin/cut
    configure:3575: result: /usr/bin/cut
    configure:3584: checking for sed
    configure:3602: found /bin/sed
    configure:3614: result: /bin/sed
    configure:3623: checking for uname
    configure:3641: found /bin/uname
    configure:3653: result: /bin/uname
    configure:3660: checking whether ln -s works
    configure:3664: result: yes
    configure:3673: checking for rm
    configure:3691: found /bin/rm
    configure:3703: result: /bin/rm
    configure:3712: checking for xargs
    configure:3730: found /usr/bin/xargs
    configure:3742: result: /usr/bin/xargs
    configure:4227: checking for Talpa version
    configure:4229: result: 1.11.0
    configure:4256: checking for operating system
    configure:4269: result: Linux
    configure:4298: checking for kernel headers layout
    configure:4345: result: /lib/modules/4.15.0-45-generic/build/include:/lib/modules/4.15.0-45-generic/build/arch/x86/include
    configure:4359: checking for linux/version.h
    configure:4383: error: cannot proceed without the required header file

    ## ---------------- ##
    ## Cache variables. ##
    ## ---------------- ##

    ac_cv_c_compiler_gnu=yes
    ac_cv_env_CC_set=
    ac_cv_env_CC_value=
    ac_cv_env_CFLAGS_set=
    ac_cv_env_CFLAGS_value=
    ac_cv_env_CPPFLAGS_set=
    ac_cv_env_CPPFLAGS_value=
    ac_cv_env_LDFLAGS_set=
    ac_cv_env_LDFLAGS_value=
    ac_cv_env_build_alias_set=
    ac_cv_env_build_alias_value=
    ac_cv_env_host_alias_set=
    ac_cv_env_host_alias_value=
    ac_cv_env_target_alias_set=
    ac_cv_env_target_alias_value=
    ac_cv_exeext=
    ac_cv_objext=o
    ac_cv_path_CAT=/bin/cat
    ac_cv_path_CUT=/usr/bin/cut
    ac_cv_path_RM=/bin/rm
    ac_cv_path_SED=/bin/sed
    ac_cv_path_UNAME=/bin/uname
    ac_cv_path_XARGS=/usr/bin/xargs
    ac_cv_path_install='/usr/bin/install -c'
    ac_cv_prog_AWK=mawk
    ac_cv_prog_ac_ct_CC=gcc
    ac_cv_prog_ac_ct_MODULELINKER=ld
    ac_cv_prog_cc_g=yes
    ac_cv_prog_cc_gcc_c_o=yes
    ac_cv_prog_cc_stdc=
    ac_cv_prog_egrep='grep -E'
    ac_cv_prog_make_make_set=yes
    am_cv_CC_dependencies_compiler_type=gcc3
    am_cv_prog_tar_ustar=gnutar

    ## ----------------- ##
    ## Output variables. ##
    ## ----------------- ##

    ACLOCAL='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run aclocal-1.9'
    AMDEPBACKSLASH='\'
    AMDEP_FALSE='#'
    AMDEP_TRUE=''
    AMTAR='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run tar'
    AUTOCONF='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run autoconf'
    AUTOHEADER='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run autoheader'
    AUTOMAKE='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run automake-1.9'
    AWK='mawk'
    BINARYSYSCTL_FALSE=''
    BINARYSYSCTL_TRUE=''
    BUILDDUALFS_FALSE=''
    BUILDDUALFS_TRUE=''
    BUILDLSM_FALSE=''
    BUILDLSM_TRUE=''
    BUILDPROCFS_FALSE=''
    BUILDPROCFS_TRUE=''
    BUILDSECURITYFS_FALSE=''
    BUILDSECURITYFS_TRUE=''
    BUILDSTACKER_FALSE=''
    BUILDSTACKER_TRUE='#'
    CAT='/bin/cat'
    CC='gcc'
    CCDEPMODE='depmode=gcc3'
    CFLAGS=''
    CPPFLAGS=''
    CUT='/usr/bin/cut'
    CYGPATH_W='echo'
    DEFS=''
    DEPDIR='.deps'
    ECHO_C=''
    ECHO_N='-n'
    ECHO_T=''
    EGREP='grep -E'
    EXEEXT=''
    INSTALL_DATA='${INSTALL} -m 644'
    INSTALL_PROGRAM='${INSTALL}'
    INSTALL_SCRIPT='${INSTALL}'
    INSTALL_STRIP_PROGRAM='${SHELL} $(install_sh) -c -s'
    KBUILD26_FALSE=''
    KBUILD26_TRUE=''
    KBUILDUSEM_FALSE=''
    KBUILDUSEM_TRUE=''
    LDFLAGS=''
    LIBOBJS=''
    LIBS=''
    LN_S='ln -s'
    LTLIBOBJS=''
    MAINT='#'
    MAINTAINER_MODE_FALSE=''
    MAINTAINER_MODE_TRUE='#'
    MAKEINFO='${SHELL} /home/abhishek/Abhi_Work/talpa-1.11.0/config/missing --run makeinfo'
    MODULELINKER='ld'
    OBJEXT='o'
    PACKAGE='talpa'
    PACKAGE_BUGREPORT=''
    PACKAGE_NAME='talpa'
    PACKAGE_STRING='talpa 1.11.0'
    PACKAGE_TARNAME='talpa'
    PACKAGE_VERSION='1.11.0'
    PATH_SEPARATOR=':'
    RM='/bin/rm'
    SED='/bin/sed'
    SET_MAKE=''
    SHELL='/bin/bash'
    STRIP=''
    TESTXWORKAROUND_FALSE=''
    TESTXWORKAROUND_TRUE=''
    UNAME='/bin/uname'
    VERSION='1.11.0'
    XARGS='/usr/bin/xargs'
    ac_ct_CC='gcc'
    ac_ct_MODULELINKER='ld'
    ac_ct_STRIP=''
    am__fastdepCC_FALSE='#'
    am__fastdepCC_TRUE=''
    am__include='include'
    am__leading_dot='.'
    am__quote=''
    am__tar='tar --format=ustar -chf - "$$tardir"'
    am__untar='tar -xf -'
    assert=''
    backportedprefetch=''
    binarysysctl=''
    bindir='${exec_prefix}/bin'
    bool=''
    build_alias=''
    builddualfs=''
    buildprocfs=''
    buildsecurityfs=''
    datadir='${prefix}/share'
    debug=''
    dotruncateaddr=''
    dotruncatetype=''
    dpath=''
    dualfs=''
    exec_prefix='NONE'
    execve=''
    filldirbackport=''
    freetaskflag=''
    hassetpages=''
    hidden=''
    host_alias=''
    hrtimers=''
    imapathcheck=''
    includedir='${prefix}/include'
    infodir='${prefix}/info'
    inodeiprivate=''
    inodemutex=''
    install_sh='/home/abhishek/Abhi_Work/talpa-1.11.0/config/install-sh'
    interceptor_module=''
    interceptor_name=''
    jiffiesbackport=''
    kerneldir='/lib/modules/4.15.0-45-generic/build'
    kernelhdrspath='/lib/modules/4.15.0-45-generic/build/include:/lib/modules/4.15.0-45-generic/build/arch/x86/include'
    kernelincludes=''
    kfuncchpgattraddr=''
    ko=''
    libdir='${exec_prefix}/lib'
    libexecdir='${exec_prefix}/libexec'
    localstatedir='${prefix}/var'
    lsm2610=''
    lsm2614=''
    lsm265=''
    lsm266=''
    lsm=''
    lsmkeys=''
    mandir='${prefix}/man'
    map_writable=''
    mkdir_p='mkdir -p --'
    mutexes=''
    needsvacpa=''
    newparent=''
    nopasymbol=''
    notasklistlock=''
    oldincludedir='/usr/include'
    pathlookup=''
    prefix='NONE'
    printkaddr=''
    program_transform_name='s,x,x,'
    rcubackport=''
    rodata=''
    samefile=''
    sbindir='${exec_prefix}/sbin'
    securityfs=''
    sharedstatedir='${prefix}/com'
    signalbackport=''
    snprintf=''
    sourcedir='/lib/modules/4.15.0-45-generic/source'
    syscallhook=''
    sysconfdir='${prefix}/etc'
    talpaversion=''
    target_alias=''
    tasknewtty=''
    vfsmntlock=''
    vfsunlink=''
    xhack='-DTALPA_HAS_XHACK'

    ## ----------- ##
    ## confdefs.h. ##
    ## ----------- ##

    #define PACKAGE "talpa"
    #define PACKAGE "talpa"
    #define PACKAGE_BUGREPORT ""
    #define PACKAGE_NAME "talpa"
    #define PACKAGE_STRING "talpa 1.11.0"
    #define PACKAGE_TARNAME "talpa"
    #define PACKAGE_VERSION "1.11.0"
    #define VERSION "1.11.0"
    #define VERSION "1.11.0"

    configure: exit 1

     

    Thank you.

  • In reply to Abhishek Thorat:

    Hi  

    Please check the location /lib/modules/4.15.0-45-generic/build/include:/lib/modules/4.15.0-45-generic/build/arch/x86/include and confirm whether version.h is available in that place.

  • In reply to Jasmin:

    Hi Jasmin,

    I had already checked the location for version.h file. It was not present at that location for which I had raised this question.

    How do I fix this?

     

    Thank you

  • In reply to Abhishek Thorat:

    Hi Abhishek,

    You can install kernel headers by running the below command:

    sudo apt-get install linux-headers-$(uname -r)

    Alternatively if this does not work you can skip using Talpa and try Fanotify instead:

    /opt/sophos-av/bin/savconfig set DisableFanotify false (Enables Fanotify)
    /opt/sophos-av/bin/savconfig set PreferFanotify true (Makes changes persistent)
    /etc/init.d/sav-protect restart (Needed for changes to apply)

    From: https://community.sophos.com/kb/en-us/118216

  • In reply to MEric:

    Hi  

     has suggested the correct way and also you can check the version.h in the system if it is stored any other location. Sometimes, you have the headers installed on the machine but the headers which it is looking for might not be available for the kernel version you have currently.

  • In reply to MEric:

    Hello all,

    I'd recommend the linux-headers-generic metapackage

    Christian

  • In reply to MEric:

    Hi MEric,

    Thank you for your suggestion, but I am specifically trying to use Talpa. Also, Have tried out the command

    sudo apt-get install linux-headers-$(uname -r)

    but with no success.

    Thanks,
    Abhishek
  • In reply to QC:

    Hi,

    Can you please help me with this. How do I use this Metapackage?

    Thanks in advance.

  • In reply to Abhishek Thorat:

    Hello Abhishek,

    just specify the generic package instead of the specific kernel version:

    sudo apt-get update sudo apt-get install linux-generic

    You still get the same error when trying to compile Talpa?

    Christian

    First Name
    Last Name
    MUW
    Address-M
    Address-P
    Phone-W
    Phone-M
    e-mail M
    e-mail I
    e-mail G
    URL
    $GeneratePassword,6$Generate Password
    $LastPassword$Repeat Last Password
    Medizinische Universität Wien
    242756

  • In reply to QC:

    Hi,

    I did try this commands, but the problem still persists.

    Is there any configuration changes which I need to do to configure file?

    Thanks,